<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_CommonPriceBreakdownReduced StructType
 * @subpackage Structs
 */
class JP_CommonPriceBreakdownReduced extends AbstractStructBase
{
    /**
     * The Base
     * @var float
     */
    public $Base;
    /**
     * The Amount
     * @var float
     */
    public $Amount;
    /**
     * Constructor method for JP_CommonPriceBreakdownReduced
     * @uses JP_CommonPriceBreakdownReduced::setBase()
     * @uses JP_CommonPriceBreakdownReduced::setAmount()
     * @param float $base
     * @param float $amount
     */
    public function __construct($base = null, $amount = null)
    {
        $this
            ->setBase($base)
            ->setAmount($amount);
    }
    /**
     * Get Base value
     * @return float|null
     */
    public function getBase()
    {
        return $this->Base;
    }
    /**
     * Set Base value
     * @param float $base
     * @return \StructType\JP_CommonPriceBreakdownReduced
     */
    public function setBase($base = null)
    {
        // validation for constraint: float
        if (!is_null($base) && !(is_float($base) || is_numeric($base))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($base, true), gettype($base)), __LINE__);
        }
        $this->Base = $base;
        return $this;
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \StructType\JP_CommonPriceBreakdownReduced
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: float
        if (!is_null($amount) && !(is_float($amount) || is_numeric($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_CommonPriceBreakdownReduced
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
